"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DconfContextProvider = exports.DconfContext = void 0;
var react_1 = __importDefault(require("react"));
var agent_1 = require("@dfinity/agent");
// @ts-ignore
var dconf_did_js_1 = require("./declarations/dconf/dconf.did.js");
exports.DconfContext = react_1.default.createContext({ configurations: {}, isReady: false });
// Defaults
var DCONF_HOST = 'https://ic0.app';
var DCONF_CANISTER_ID = '3izmc-5qaaa-aaaal-abjkq-cai';
function DconfContextProvider(_a) {
    var children = _a.children, dconfCanisterId = _a.dconfCanisterId, applicationId = _a.applicationId, environmentId = _a.environmentId, host = _a.host;
    var _b = react_1.default.useState(true), isFetching = _b[0], setIsFetching = _b[1];
    var _c = react_1.default.useState({}), configValues = _c[0], setConfigValues = _c[1];
    var isDevMode = !!host;
    var agent = new agent_1.HttpAgent({
        host: host || DCONF_HOST,
    });
    var actor = agent_1.Actor.createActor(dconf_did_js_1.idlFactory, {
        agent: agent,
        canisterId: dconfCanisterId || DCONF_CANISTER_ID,
    });
    function getConfigValues() {
        return __awaiter(this, void 0, void 0, function () {
            var response, configurations, _i, response_1, entry, formattedValue;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!isDevMode) return [3 /*break*/, 2];
                        return [4 /*yield*/, agent.fetchRootKey()];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2: return [4 /*yield*/, actor.getAllConfigValues(applicationId, environmentId)
                            .then(function (r) { return r.ok; })];
                    case 3:
                        response = _a.sent();
                        configurations = {};
                        for (_i = 0, response_1 = response; _i < response_1.length; _i++) {
                            entry = response_1[_i];
                            formattedValue = entry.value;
                            if (entry.valueType.boolean !== undefined) {
                                formattedValue = formattedValue === 'true' ? true : formattedValue;
                                formattedValue = formattedValue === 'false' ? false : formattedValue;
                            }
                            else if (entry.valueType.number !== undefined) {
                                formattedValue = Number(formattedValue);
                            }
                            configurations[entry.key] = formattedValue;
                        }
                        return [2 /*return*/, configurations];
                }
            });
        });
    }
    var didCancel = false;
    react_1.default.useEffect(function () {
        setIsFetching(true);
        getConfigValues().
            then(function (res) {
            setIsFetching(false);
            if (!didCancel) {
                setConfigValues(res);
            }
        })
            .catch(function (error) {
            console.error("dconf: error fetching configurations ", error);
            setIsFetching(false);
        });
        return function () {
            didCancel = true;
        };
    }, [dconfCanisterId, applicationId, environmentId, host,]);
    return (react_1.default.createElement(exports.DconfContext.Provider, { value: { configurations: configValues, isReady: !isFetching } }, children));
}
exports.DconfContextProvider = DconfContextProvider;
