"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.init = exports.idlFactory = void 0;
var idlFactory = function (_a) {
    var IDL = _a.IDL;
    var Result = IDL.Variant({ 'ok': IDL.Text, 'err': IDL.Text });
    var ConfigurationTypes = IDL.Variant({
        'string': IDL.Null,
        'boolean': IDL.Null,
        'number': IDL.Null,
    });
    var ConfigurationValueForEnv = IDL.Record({
        'key': IDL.Text,
        'value': IDL.Text,
        'isPrivate': IDL.Bool,
        'valueType': ConfigurationTypes,
        'environmentId': IDL.Text,
    });
    var Result_3 = IDL.Variant({
        'ok': IDL.Vec(ConfigurationValueForEnv),
        'err': IDL.Text,
    });
    var Configuration = IDL.Record({
        'key': IDL.Text,
        'isPrivate': IDL.Bool,
        'valueType': ConfigurationTypes,
        'defaultValue': IDL.Text,
    });
    var ConfigurationList = IDL.Vec(Configuration);
    var Environment = IDL.Record({ 'id': IDL.Text, 'name': IDL.Text });
    var EnvironmentList = IDL.Vec(Environment);
    var Application = IDL.Record({
        'id': IDL.Text,
        'owner': IDL.Principal,
        'name': IDL.Text,
        'configurations': ConfigurationList,
        'environments': EnvironmentList,
    });
    var Result_2 = IDL.Variant({ 'ok': Application, 'err': IDL.Text });
    var Result_1 = IDL.Variant({
        'ok': IDL.Vec(Application),
        'err': IDL.Text,
    });
    return IDL.Service({
        'createApplication': IDL.Func([IDL.Text, IDL.Text], [Result], []),
        'createConfiguration': IDL.Func([IDL.Text, IDL.Text, ConfigurationTypes, IDL.Text, IDL.Bool], [Result], []),
        'createEnvironment': IDL.Func([IDL.Text, IDL.Text, IDL.Text], [Result], []),
        'getAllConfigValues': IDL.Func([IDL.Text, IDL.Text], [Result_3], []),
        'getApplication': IDL.Func([IDL.Text], [Result_2], []),
        'getConfigValue': IDL.Func([IDL.Text, IDL.Text, IDL.Text], [Result], []),
        'getOwnedApplications': IDL.Func([], [Result_1], []),
        'removeApplication': IDL.Func([IDL.Text], [Result], []),
        'removeConfiguration': IDL.Func([IDL.Text, IDL.Text], [Result], []),
        'removeEnvironment': IDL.Func([IDL.Text, IDL.Text], [Result], []),
        'setConfigValue': IDL.Func([IDL.Text, IDL.Text, IDL.Text, IDL.Text], [Result], []),
    });
};
exports.idlFactory = idlFactory;
var init = function (_a) {
    var IDL = _a.IDL;
    return [];
};
exports.init = init;
