"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.dconf_app = exports.createActor = exports.canisterId = exports.idlFactory = void 0;
var agent_1 = require("@dfinity/agent");
// Imports and re-exports candid interface
var dconf_app_did_js_1 = require("./dconf_app.did.js");
var dconf_app_did_js_2 = require("./dconf_app.did.js");
Object.defineProperty(exports, "idlFactory", { enumerable: true, get: function () { return dconf_app_did_js_2.idlFactory; } });
// CANISTER_ID is replaced by webpack based on node environment
exports.canisterId = process.env.DCONF_APP_CANISTER_ID;
/**
 *
 * @param {string | import("@dfinity/principal").Principal} canisterId Canister ID of Agent
 * @param {{agentOptions?: import("@dfinity/agent").HttpAgentOptions; actorOptions?: import("@dfinity/agent").ActorConfig}} [options]
 * @return {import("@dfinity/agent").ActorSubclass<import("./dconf_app.did.js")._SERVICE>}
 */
var createActor = function (canisterId, options) {
    var agent = new agent_1.HttpAgent(options ? __assign({}, options.agentOptions) : {});
    // Fetch root key for certificate validation during development
    if (process.env.NODE_ENV !== "production") {
        agent.fetchRootKey().catch(function (err) {
            console.warn("Unable to fetch root key. Check to ensure that your local replica is running");
            console.error(err);
        });
    }
    // Creates an actor with using the candid interface and the HttpAgent
    return agent_1.Actor.createActor(dconf_app_did_js_1.idlFactory, __assign({ agent: agent, canisterId: canisterId }, (options ? options.actorOptions : {})));
};
exports.createActor = createActor;
/**
 * A ready-to-use agent for the dconf_app canister
 * @type {import("@dfinity/agent").ActorSubclass<import("./dconf_app.did.js")._SERVICE>}
 */
exports.dconf_app = (0, exports.createActor)(exports.canisterId);
